clear;clc;
%% 3m motif
pattern3m = [6 12 14 36 38 46 74 78 98 102 108 110 238];

a3m=zeros(3,3,13);
for i=1:length(pattern3m)
    temp = dec2bin(pattern3m(i),9);
    temp2 = temp-48;
    temp3 = reshape(temp2,3,3);
    a3m(:,:,i) = temp3';
    e3m(:,i) = eig(a3m(:,:,i));
    [Ve3m(:,:,i),de3m(:,:,i)] = eig(a3m(:,:,i));
end
%% 3m LA
in3m=zeros(3,3,13);
DplusA3m=zeros(3,3,13);

for i=1:length(pattern3m)
    in3m(:,:,i)=diag(sum(a3m(:,:,i)))+diag(sum(a3m(:,:,i)'))-a3m(:,:,i); %D-A
    DplusA3m(:,:,i)=diag(sum(a3m(:,:,i)))+diag(sum(a3m(:,:,i)'))+a3m(:,:,i); %D+A
   
    ea3m(:,i) = eig(a3m(:,:,i)); %A eigenvalue
    ie3m(:,i) = eig(in3m(:,:,i)); %DmA eigenvalue
    DplusAe3m(:,i) = eig(DplusA3m(:,:,i)); %DpA eigenvalue
  
    [iVa3m(:,:,i),ida3m(:,:,i)] = eig(a3m(:,:,i)); % eigenvector
    [iVe3m(:,:,i),ide3m(:,:,i)] = eig(in3m(:,:,i)); % eigenvector
    [DplusVe3m(:,:,i),Dplusde3m(:,:,i)] = eig(DplusA3m(:,:,i)); % eigenvector
 
    %gamma3m(:,i)=ie3m(:,i)-(((sum(sum(a3m(:,:,i))))*2)/3);
    %Dplusgamma3m(:,i)=DplusAe3m(:,i)-(((sum(sum(a3m(:,:,i))))*2)/3);
    DIFFa3m(:,:,i)=a3m(:,:,i)*iVa3m(:,:,i)-iVa3m(:,:,i)*ida3m(:,:,i);
    a3mMM(:,:,i)=a3m(:,:,i)*a3m(:,:,i)'; %A*At
    a3mMMt(:,:,i)=a3m(:,:,i)'*a3m(:,:,i); %At*A
    [iVa3mMM(:,:,i),ida3mMM(:,:,i)] = eig(a3mMM(:,:,i)); % eigenvector
    [iVa3mMMt(:,:,i),ida3mMMt(:,:,i)] = eig(a3mMMt(:,:,i)); % eigenvector
    
    in3mMM(:,:,i)=in3m(:,:,i)*in3m(:,:,i)';%DmA*DmAt
    in3mMMt(:,:,i)=in3m(:,:,i)'*in3m(:,:,i);%DmAt*DmA
    [iVin3mMM(:,:,i),idin3mMM(:,:,i)] = eig(in3mMM(:,:,i)); % eigenvector
    [iVin3mMMt(:,:,i),idin3mMMt(:,:,i)] = eig(in3mMMt(:,:,i)); % eigenvector
   
    DplusA3mMM(:,:,i)=DplusA3m(:,:,i)*DplusA3m(:,:,i)';%DpA*DpAt
    DplusA3mMMt(:,:,i)=DplusA3m(:,:,i)'*DplusA3m(:,:,i);%DpAt*DpA
    [iVDplusA3mMM(:,:,i),idDplusA3mMM(:,:,i)] = eig(DplusA3mMM(:,:,i)); % eigenvector
    [iVDplusA3mMMt(:,:,i),idDplusA3mMMt(:,:,i)] = eig(DplusA3mMMt(:,:,i)); % eigenvector
    
    inDplus3mMM(:,:,i)=in3m(:,:,i)*DplusA3m(:,:,i)';%DmADpAt
    DplusinA3mMM(:,:,i)=DplusA3m(:,:,i)*in3m(:,:,i)';%DpAtDmA
    aDplus3mMM(:,:,i)=a3m(:,:,i)*DplusA3m(:,:,i)';%A*DpAt
    ainA3mMM(:,:,i)=a3m(:,:,i)*in3m(:,:,i)';%A*DmAt
    inin3mMM(:,:,i)=in3m(:,:,i)*in3m(:,:,i);%DmA*DmA
    DplusDpA3mMM(:,:,i)=DplusA3m(:,:,i)*DplusA3m(:,:,i);%DpA*DpA
    DmaDplus3mMM(:,:,i)=in3m(:,:,i)*DplusA3m(:,:,i);%DmA*DpA
    [aDplus3mMMV(:,:,i),aDplus3mMME(:,:,i)] = eig(aDplus3mMM(:,:,i)); % eigenvector
    [ainA3mMMV(:,:,i),ainA3mMME(:,:,i)] = eig(ainA3mMM(:,:,i)); % eigenvector
    [inin3mMMV(:,:,i),inin3mMME(:,:,i)] = eig(inin3mMM(:,:,i)); % eigenvector
    [DplusDpA3mMMV(:,:,i),DplusDpA3mMME(:,:,i)] = eig(DplusDpA3mMM(:,:,i)); % eigenvector
    [DmaDplus3mMMV(:,:,i),DmaDplus3mMME(:,:,i)] = eig(DmaDplus3mMM(:,:,i)); % eigenvector
    
    ae3mMM(:,i)=eig(a3mMM(:,:,i)); %A*At eigenvalue
    ae3mMMt(:,i)=eig(a3mMMt(:,:,i)); %At*A eigenvalue
    ide3mMM(:,i) = eig(in3mMM(:,:,i)); %DmA*DmAt eigenvalue
    ide3mMMt(:,i) = eig(in3mMMt(:,:,i)); %DmAt*DmA eigenvalue
    DplusAe3mMM(:,i) = eig(DplusA3mMM(:,:,i)); %DpA*DpAt eigenvalue
    DplusAe3mMMt(:,i) = eig(DplusA3mMMt(:,:,i)); %DpAt*DpA eigenvalue
    inDpluse3mMM(:,i) = eig(inDplus3mMM(:,:,i));%DmA*DpAt eigenvalue
    DDplusinAe3mMM(:,i) = eig(DplusinA3mMM(:,:,i));%DpA*DmAt eigenvalue
    aDpluse3mMM(:,i) = eig(aDplus3mMM(:,:,i));%A*DpAt eigenvalue
    ainAe3mMM(:,i) = eig(ainA3mMM(:,:,i));%A*DmAt eigenvalue    
    inine3mMM(:,i) = eig(inin3mMM(:,:,i)); %DmA*DmA eigenvalue
    DplusDpAe3mMM(:,i) = eig(DplusDpA3mMM(:,:,i)); %DpA*DpA eigenvalue
    DmaDpluse3mMM(:,i) = eig(DmaDplus3mMM(:,:,i)); %DpA*DpA eigenvalue
    
    absDmAenergy3m(:,i) = sum(abs(ie3m(:,i)))-(((sum(sum(a3m(:,:,i))))*2)/3); % DmAenergy -2e/N
    absDpAergy3m(:,i) = sum(abs(DplusAe3m(:,i)))-(((sum(sum(a3m(:,:,i))))*2)/3); % DpAenergy -2e/N
    
end

iVa3m(find(abs(iVa3m)<0.000001)) = 0;%millionth=0
iVa3m = round (iVa3m,3,'significant');%significant digit
iVe3m(find(abs(iVe3m)<0.000001)) = 0;
iVe3m = round (iVe3m,3,'significant');
DplusVe3m(find(abs(DplusVe3m)<0.000001)) = 0;
DplusVe3m = round (DplusVe3m,3,'significant');
iVa3mMM(find(abs(iVa3mMM)<0.000001)) = 0;
iVa3mMM = round (iVa3mMM,3,'significant');
iVa3mMMt(find(abs(iVa3mMMt)<0.000001)) = 0;
iVa3mMMt = round (iVa3mMMt,3,'significant');
iVin3mMM(find(abs(iVin3mMM)<0.000001)) = 0;
iVin3mMM = round (iVin3mMM,3,'significant');
iVin3mMMt(find(abs(iVin3mMMt)<0.000001)) = 0;
iVin3mMMt = round (iVin3mMMt,3,'significant');
iVDplusA3mMM(find(abs(iVDplusA3mMM)<0.000001)) = 0;
iVDplusA3mMM = round (iVDplusA3mMM,3,'significant');
iVDplusA3mMMt(find(abs(iVDplusA3mMMt)<0.000001)) = 0;
iVDplusA3mMMt = round (iVDplusA3mMMt,3,'significant');
inDpluse3mMM(find(abs(inDpluse3mMM)<0.000001)) = 0;
inDpluse3mMM = round (inDpluse3mMM,3,'significant');
DDplusinAe3mMM(find(abs(DDplusinAe3mMM)<0.000001)) = 0;
DDplusinAe3mMM = round (DDplusinAe3mMM,3,'significant');
aDpluse3mMM(find(abs(aDpluse3mMM)<0.000001)) = 0;
aDpluse3mMM = round (aDpluse3mMM,3,'significant');
ainAe3mMM(find(abs(ainAe3mMM)<0.000001)) = 0;
ainAe3mMM = round (ainAe3mMM,3,'significant');

%{
absea3m = abs(ea3m);
absie3m = abs(ie3m);
abssqrtie3m = sum(abs(sqrt(ie3m)));
absDplusAe3m = abs(DplusAe3m);
abssqrtDplusAe3m = sum(abs(sqrt(DplusAe3m)));
%}

absaenergy3m = sum(abs(ea3m)); %energy A
%absDmAenergy3mon = sum(abs(ie3m)); %energy DmA
%absDpAergy3mon = sum(abs(DplusAe3m)); %energy DpA
absAAtenergy3m = sum(abs(sqrt(ae3mMM))); %energy A*At
absAtAenergy3m = sum(abs(sqrt(ae3mMMt))); %energy At*A
absDmAAAtenergy3m = sum(abs(sqrt(ide3mMM))); %energy DmA*DmAt
absDmAAtAenergy3m = sum(abs(sqrt(ide3mMMt))); %energy DmAt*DmA
absDpAAAtenergy3m = sum(abs(sqrt(DplusAe3mMM))); %energy DpA*DpAt
absDpAAtAenergy3m = sum(abs(sqrt(DplusAe3mMMt))); %energy DpAt*DpA
absDmADpAtenergy3m = sum(abs(sqrt(inDpluse3mMM))); %energy DpA*DpAt
absDpADmAtenergy3m = sum(abs(sqrt(DDplusinAe3mMM))); %energy DpAt*DpA
absADpAtenergy3m = sum(abs(sqrt(aDpluse3mMM))); %energy A*DpAt
absADmAtenergy3m = sum(abs(sqrt(ainAe3mMM))); %energy A*DmAt


AM=ea3m;
DMAM=ie3m;
DPAM=DplusAe3m;
AATM=ae3mMM;
DMA2=inine3mMM;
DPA2=DplusDpAe3mMM;
ADMAT=ainAe3mMM;
ADPAT=aDpluse3mMM;
DMADPA=DmaDpluse3mMM;

AMsV=iVa3m;
DMAMs=iVe3m;
DPAMs=DplusVe3m;
AATMs=iVa3mMM;
DMA2s=inin3mMMV;
DPA2s=DplusDpA3mMMV;
ADMATs=ainA3mMMV;
ADPATs=aDplus3mMMV;
DMADPAs=DmaDplus3mMMV;
%1
for i=1:13
    if AM(1,i)>AM(2,i)
        temp=AM(1,i);
        AM(1,i)=AM(2,i);
        AM(2,i)=temp;
        temp=AMsV(:,1,i);
        AMsV(:,1,i)=AMsV(:,2,i);
        AMsV(:,2,i)=temp;
    end
    if AM(2,i)>AM(3,i)
        temp=AM(2,i);
        AM(2,i)=AM(3,i);
        AM(3,i)=temp;
        temp=AMsV(:,2,i);
        AMsV(:,2,i)=AMsV(:,3,i);
        AMsV(:,3,i)=temp;
    end
    if AM(1,i)>AM(2,i)
        temp=AM(1,i);
        AM(1,i)=AM(2,i);
        AM(2,i)=temp;
        temp=AMsV(:,1,i);
        AMsV(:,1,i)=AMsV(:,2,i);
        AMsV(:,2,i)=temp;
    end
end
%2
for i=1:13
    if DMAM(1,i)>DMAM(2,i)
        temp=DMAM(1,i);
        DMAM(1,i)=DMAM(2,i);
        DMAM(2,i)=temp;
        temp=DMAMs(:,1,i);
        DMAMs(:,1,i)=DMAMs(:,2,i);
        DMAMs(:,2,i)=temp;
    end
    if DMAM(2,i)>DMAM(3,i)
        temp=DMAM(2,i);
        DMAM(2,i)=DMAM(3,i);
        DMAM(3,i)=temp;
        temp=DMAMs(:,2,i);
        DMAMs(:,2,i)=DMAMs(:,3,i);
        DMAMs(:,3,i)=temp;
    end
    if DMAM(1,i)>DMAM(2,i)
        temp=DMAM(1,i);
        DMAM(1,i)=DMAM(2,i);
        DMAM(2,i)=temp;
        temp=DMAMs(:,1,i);
        DMAMs(:,1,i)=DMAMs(:,2,i);
        DMAMs(:,2,i)=temp;
    end
end 
%3
for i=1:13
    if DPAM(1,i)>DPAM(2,i)
        temp=DPAM(1,i);
        DPAM(1,i)=DPAM(2,i);
        DPAM(2,i)=temp;
        temp=DPAMs(:,1,i);
        DPAMs(:,1,i)=DPAMs(:,2,i);
        DPAMs(:,2,i)=temp;
    end
    if DPAM(2,i)>DPAM(3,i)
        temp=DPAM(2,i);
        DPAM(2,i)=DPAM(3,i);
        DPAM(3,i)=temp;
        temp=DPAMs(:,2,i);
        DPAMs(:,2,i)=DPAMs(:,3,i);
        DPAMs(:,3,i)=temp;
    end
    if DPAM(1,i)>DPAM(2,i)
        temp=DPAM(1,i);
        DPAM(1,i)=DPAM(2,i);
        DPAM(2,i)=temp;
        temp=DPAMs(:,1,i);
        DPAMs(:,1,i)=DPAMs(:,2,i);
        DPAMs(:,2,i)=temp;
    end
end
%4
for i=1:13
    if AATM(1,i)>AATM(2,i)
        temp=AATM(1,i);
        AATM(1,i)=AATM(2,i);
        AATM(2,i)=temp;
        temp=AATMs(:,1,i);
        AATMs(:,1,i)=AATMs(:,2,i);
        AATMs(:,2,i)=temp;
    end
    if AATM(2,i)>AATM(3,i)
        temp=AATM(2,i);
        AATM(2,i)=AATM(3,i);
        AATM(3,i)=temp;
        temp=AATMs(:,2,i);
        AATMs(:,2,i)=AATMs(:,3,i);
        AATMs(:,3,i)=temp;
    end
    if AATM(1,i)>AATM(2,i)
        temp=AATM(1,i);
        AATM(1,i)=AATM(2,i);
        AATM(2,i)=temp;
        temp=AATMs(:,1,i);
        AATMs(:,1,i)=AATMs(:,2,i);
        AATMs(:,2,i)=temp;
    end
end
%5
for i=1:13
    if DMA2(1,i)>DMA2(2,i)
        temp=DMA2(1,i);
        DMA2(1,i)=DMA2(2,i);
        DMA2(2,i)=temp;
        temp=DMA2s(:,1,i);
        DMA2s(:,1,i)=DMA2s(:,2,i);
        DMA2s(:,2,i)=temp;
    end
    if DMA2(2,i)>DMA2(3,i)
        temp=DMA2(2,i);
        DMA2(2,i)=DMA2(3,i);
        DMA2(3,i)=temp;
        temp=DMA2s(:,2,i);
        DMA2s(:,2,i)=DMA2s(:,3,i);
        DMA2s(:,3,i)=temp;
    end
    if DMA2(1,i)>DMA2(2,i)
        temp=DMA2(1,i);
        DMA2(1,i)=DMA2(2,i);
        DMA2(2,i)=temp;
        temp=DMA2s(:,1,i);
        DMA2s(:,1,i)=DMA2s(:,2,i);
        DMA2s(:,2,i)=temp;
    end
end
%6
for i=1:13
    if DPA2(1,i)>DPA2(2,i)
        temp=DPA2(1,i);
        DPA2(1,i)=DPA2(2,i);
        DPA2(2,i)=temp;
        temp=DPA2s(:,1,i);
        DPA2s(:,1,i)=DPA2s(:,2,i);
        DPA2s(:,2,i)=temp;
    end
    if DPA2(2,i)>DPA2(3,i)
        temp=DPA2(2,i);
        DPA2(2,i)=DPA2(3,i);
        DPA2(3,i)=temp;
        temp=DPA2s(:,2,i);
        DPA2s(:,2,i)=DPA2s(:,3,i);
        DPA2s(:,3,i)=temp;
    end
    if DPA2(1,i)>DPA2(2,i)
        temp=DPA2(1,i);
        DPA2(1,i)=DPA2(2,i);
        DPA2(2,i)=temp;
        temp=DPA2s(:,1,i);
        DPA2s(:,1,i)=DPA2s(:,2,i);
        DPA2s(:,2,i)=temp;
    end
end
%7
for i=1:13
    if ADMAT(1,i)>ADMAT(2,i)
        temp=ADMAT(1,i);
        ADMAT(1,i)=ADMAT(2,i);
        ADMAT(2,i)=temp;
        temp=ADMATs(:,1,i);
        ADMATs(:,1,i)=ADMATs(:,2,i);
        ADMATs(:,2,i)=temp;
    end
    if ADMAT(2,i)>ADMAT(3,i)
        temp=ADMAT(2,i);
        ADMAT(2,i)=ADMAT(3,i);
        ADMAT(3,i)=temp;
        temp=ADMATs(:,2,i);
        ADMATs(:,2,i)=ADMATs(:,3,i);
        ADMATs(:,3,i)=temp;
    end
    if ADMAT(1,i)>ADMAT(2,i)
        temp=ADMAT(1,i);
        ADMAT(1,i)=ADMAT(2,i);
        ADMAT(2,i)=temp;
        temp=ADMATs(:,1,i);
        ADMATs(:,1,i)=ADMATs(:,2,i);
        ADMATs(:,2,i)=temp;
    end
end
%8
for i=1:13
    if ADPAT(1,i)>ADPAT(2,i)
        temp=ADPAT(1,i);
        ADPAT(1,i)=ADPAT(2,i);
        ADPAT(2,i)=temp;
        temp=ADPATs(:,1,i);
        ADPATs(:,1,i)=ADPATs(:,2,i);
        ADPATs(:,2,i)=temp;
    end
    if ADPAT(2,i)>ADPAT(3,i)
        temp=ADPAT(2,i);
        ADPAT(2,i)=ADPAT(3,i);
        ADPAT(3,i)=temp;
        temp=ADPATs(:,2,i);
        ADPATs(:,2,i)=ADPATs(:,3,i);
        ADPATs(:,3,i)=temp;
    end
    if ADPAT(1,i)>ADPAT(2,i)
        temp=ADPAT(1,i);
        ADPAT(1,i)=ADPAT(2,i);
        ADPAT(2,i)=temp;
        temp=ADPATs(:,1,i);
        ADPATs(:,1,i)=ADPATs(:,2,i);
        ADPATs(:,2,i)=temp;
    end
end
%9
for i=1:13
    if DMADPA(1,i)>DMADPA(2,i)
        temp=DMADPA(1,i);
        DMADPA(1,i)=DMADPA(2,i);
        DMADPA(2,i)=temp;
        temp=DMADPAs(:,1,i);
        DMADPAs(:,1,i)=DMADPAs(:,2,i);
        DMADPAs(:,2,i)=temp;
    end
    if DMADPA(2,i)>DMADPA(3,i)
        temp=DMADPA(2,i);
        DMADPA(2,i)=DMADPA(3,i);
        DMADPA(3,i)=temp;
        temp=DMADPAs(:,2,i);
        DMADPAs(:,2,i)=DMADPAs(:,3,i);
        DMADPAs(:,3,i)=temp;
    end
    if DMADPA(1,i)>DMADPA(2,i)
        temp=DMADPA(1,i);
        DMADPA(1,i)=DMADPA(2,i);
        DMADPA(2,i)=temp;
        temp=DMADPAs(:,1,i);
        DMADPAs(:,1,i)=DMADPAs(:,2,i);
        DMADPAs(:,2,i)=temp;
    end
end

for i=1:length(pattern3m)
    AMs(:,:,i)=a3m(:,:,i)*AMsV(:,:,i)-AMsV(:,:,i)*diag(AM(:,i));
    DMAMsV(:,:,i)=in3m(:,:,i)*DMAMs(:,:,i)-DMAMs(:,:,i)*diag(DMAM(:,i));
    DPAMsV(:,:,i)=DplusA3m(:,:,i)*DPAMs(:,:,i)-DPAMs(:,:,i)*diag(DPAM(:,i));
    AATMsV(:,:,i)=a3mMM(:,:,i)*AATMs(:,:,i)-AATMs(:,:,i)*diag(AATM(:,i));
    DMA2sV(:,:,i)=inin3mMM(:,:,i)*DMA2s(:,:,i)-DMA2s(:,:,i)*diag(DMA2(:,i));
    DPA2sV(:,:,i)=DplusDpA3mMM(:,:,i)*DPA2s(:,:,i)-DPA2s(:,:,i)*diag(DPA2(:,i));
    ADMATsV(:,:,i)=ainA3mMM(:,:,i)*ADMATs(:,:,i)-ADMATs(:,:,i)*diag(ADMAT(:,i));
    ADPATsV(:,:,i)=aDplus3mMM(:,:,i)*ADPATs(:,:,i)-ADPATs(:,:,i)*diag(ADPAT(:,i));
    DMADPAsV(:,:,i)=DmaDplus3mMM(:,:,i)*DMADPAs(:,:,i)-DMADPAs(:,:,i)*diag(DMADPA(:,i));
end
AM(find(abs(AM)<0.000001)) = 0;%millionth=0
AM = round (AM,3,'significant');%significant digit
DMAM(find(abs(DMAM)<0.000001)) = 0;%millionth=0
DMAM = round (DMAM,3,'significant');%significant digit
DPAM(find(abs(DPAM)<0.000001)) = 0;%millionth=0
DPAM = round (DPAM,3,'significant');%significant digit
AATM(find(abs(AATM)<0.000001)) = 0;%millionth=0
AATM = round (AATM,3,'significant');%significant digit
DMA2(find(abs(DMA2)<0.000001)) = 0;%millionth=0
DMA2 = round (DMA2,3,'significant');%significant digit
DPA2(find(abs(DPA2)<0.000001)) = 0;%millionth=0
DPA2 = round (DPA2,3,'significant');%significant digit
ADMAT(find(abs(ADMAT)<0.000001)) = 0;%millionth=0
ADMAT = round (ADMAT,3,'significant');%significant digit
ADPAT(find(abs(ADPAT)<0.000001)) = 0;%millionth=0
ADPAT = round (ADPAT,3,'significant');%significant digit
DMADPA(find(abs(DMADPA)<0.000001)) = 0;%millionth=0
DMADPA = round (DMADPA,3,'significant');%significant digit

AMsV(find(abs(AMsV)<0.000001)) = 0;%millionth=0
AMsV = round (AMsV,3,'significant');%significant digit
DMAMs(find(abs(DMAMs)<0.000001)) = 0;%millionth=0
DMAMs = round (DMAMs,3,'significant');%significant digit
DPAMs(find(abs(DPAMs)<0.000001)) = 0;%millionth=0
DPAMs = round (DPAMs,3,'significant');%significant digit
AATMs(find(abs(AATMs)<0.000001)) = 0;%millionth=0
AATMs = round (AATMs,3,'significant');%significant digit
DMA2s(find(abs(DMA2s)<0.000001)) = 0;%millionth=0
DMA2s = round (DMA2s,3,'significant');%significant digit
DPA2s(find(abs(DPA2s)<0.000001)) = 0;%millionth=0
DPA2s = round (DPA2s,3,'significant');%significant digit
ADMATs(find(abs(ADMATs)<0.000001)) = 0;%millionth=0
ADMATs = round (ADMATs,3,'significant');%significant digit
ADPATs(find(abs(ADPATs)<0.000001)) = 0;%millionth=0
ADPATs = round (ADPATs,3,'significant');%significant digit
DMADPAs(find(abs(DMADPAs)<0.000001)) = 0;%millionth=0
DMADPAs = round (DMADPAs,3,'significant');%significant digit
%% пX
for i=1:length(pattern3m)    
   
outputAM1(:,i) = {mat2str(AM(1,i))};
outputAM2(:,i) = {mat2str(AM(2,i))};
outputAM3(:,i) = {mat2str(AM(3,i))};

outputDMAM1(:,i) = {mat2str(DMAM(1,i))};
outputDMAM2(:,i) = {mat2str(DMAM(2,i))};
outputDMAM3(:,i) = {mat2str(DMAM(3,i))};

outputDPAM1(:,i) = {mat2str(DPAM(1,i))};
outputDPAM2(:,i) = {mat2str(DPAM(2,i))};
outputDPAM3(:,i) = {mat2str(DPAM(3,i))};

outputAATM1(:,i) = {mat2str(AATM(1,i))};
outputAATM2(:,i) = {mat2str(AATM(2,i))};
outputAATM3(:,i) = {mat2str(AATM(3,i))};

outputDMA21(:,i) = {mat2str(DMA2(1,i))};
outputDMA22(:,i) = {mat2str(DMA2(2,i))};
outputDMA23(:,i) = {mat2str(DMA2(3,i))};

outputDPA21(:,i) = {mat2str(DPA2(1,i))};
outputDPA22(:,i) = {mat2str(DPA2(2,i))};
outputDPA23(:,i) = {mat2str(DPA2(3,i))};

outputADMAT1(:,i) = {mat2str(ADMAT(1,i))};
outputADMAT2(:,i) = {mat2str(ADMAT(2,i))};
outputADMAT3(:,i) = {mat2str(ADMAT(3,i))};

outputADPAT1(:,i) = {mat2str(ADPAT(1,i))};
outputADPAT2(:,i) = {mat2str(ADPAT(2,i))};
outputADPAT3(:,i) = {mat2str(ADPAT(3,i))};

outputDMADPA1(:,i) = {mat2str(DMADPA(1,i))};
outputDMADPA2(:,i) = {mat2str(DMADPA(2,i))};
outputDMADPA3(:,i) = {mat2str(DMADPA(3,i))};
end
    
xlswrite('energy_spectrum.xlsx', outputAM1, '3m_spectrum', 'B2');
xlswrite('energy_spectrum.xlsx', outputAM2, '3m_spectrum', 'B3');
xlswrite('energy_spectrum.xlsx', outputAM3, '3m_spectrum', 'B4');

xlswrite('energy_spectrum.xlsx', outputDMAM1, '3m_spectrum', 'B6');
xlswrite('energy_spectrum.xlsx', outputDMAM2, '3m_spectrum', 'B7');
xlswrite('energy_spectrum.xlsx', outputDMAM3, '3m_spectrum', 'B8');

xlswrite('energy_spectrum.xlsx', outputDPAM1, '3m_spectrum', 'B10');
xlswrite('energy_spectrum.xlsx', outputDPAM2, '3m_spectrum', 'B11');
xlswrite('energy_spectrum.xlsx', outputDPAM3, '3m_spectrum', 'B12');

xlswrite('energy_spectrum.xlsx', outputAATM1, '3m_spectrum', 'B14');
xlswrite('energy_spectrum.xlsx', outputAATM2, '3m_spectrum', 'B15');
xlswrite('energy_spectrum.xlsx', outputAATM3, '3m_spectrum', 'B16');

xlswrite('energy_spectrum.xlsx', outputDMA21, '3m_spectrum', 'B18');
xlswrite('energy_spectrum.xlsx', outputDMA22, '3m_spectrum', 'B19');
xlswrite('energy_spectrum.xlsx', outputDMA23, '3m_spectrum', 'B20');

xlswrite('energy_spectrum.xlsx', outputDPA21, '3m_spectrum', 'B22');
xlswrite('energy_spectrum.xlsx', outputDPA22, '3m_spectrum', 'B23');
xlswrite('energy_spectrum.xlsx', outputDPA23, '3m_spectrum', 'B24');

xlswrite('energy_spectrum.xlsx', outputADMAT1, '3m_spectrum', 'B26');
xlswrite('energy_spectrum.xlsx', outputADMAT2, '3m_spectrum', 'B27');
xlswrite('energy_spectrum.xlsx', outputADMAT3, '3m_spectrum', 'B28');

xlswrite('energy_spectrum.xlsx', outputADPAT1, '3m_spectrum', 'B30');
xlswrite('energy_spectrum.xlsx', outputADPAT2, '3m_spectrum', 'B31');
xlswrite('energy_spectrum.xlsx', outputADPAT3, '3m_spectrum', 'B32');

xlswrite('energy_spectrum.xlsx', outputDMADPA1, '3m_spectrum', 'B34');
xlswrite('energy_spectrum.xlsx', outputDMADPA2, '3m_spectrum', 'B35');
xlswrite('energy_spectrum.xlsx', outputDMADPA3, '3m_spectrum', 'B36');


%% пX
for i=1:length(pattern3m)    
   
outputAMsV1(:,i) = {mat2str(AMsV(:,1,i))};
outputAMsV2(:,i) = {mat2str(AMsV(:,2,i))};
outputAMsV3(:,i) = {mat2str(AMsV(:,3,i))};

outputDMAMs1(:,i) = {mat2str(DMAMs(:,1,i))};
outputDMAMs2(:,i) = {mat2str(DMAMs(:,2,i))};
outputDMAMs3(:,i) = {mat2str(DMAMs(:,3,i))};

outputDPAMs1(:,i) = {mat2str(DPAMs(:,1,i))};
outputDPAMs2(:,i) = {mat2str(DPAMs(:,2,i))};
outputDPAMs3(:,i) = {mat2str(DPAMs(:,3,i))};

outputAATMs1(:,i) = {mat2str(AATMs(:,1,i))};
outputAATMs2(:,i) = {mat2str(AATMs(:,2,i))};
outputAATMs3(:,i) = {mat2str(AATMs(:,3,i))};

outputDMA2s1(:,i) = {mat2str(DMA2s(:,1,i))};
outputDMA2s2(:,i) = {mat2str(DMA2s(:,2,i))};
outputDMA2s3(:,i) = {mat2str(DMA2s(:,3,i))};

outputDPA2s1(:,i) = {mat2str(DPA2s(:,1,i))};
outputDPA2s2(:,i) = {mat2str(DPA2s(:,2,i))};
outputDPA2s3(:,i) = {mat2str(DPA2s(:,3,i))};

outputADMATs1(:,i) = {mat2str(ADMATs(:,1,i))};
outputADMATs2(:,i) = {mat2str(ADMATs(:,2,i))};
outputADMATs3(:,i) = {mat2str(ADMATs(:,3,i))};

outputADPATs1(:,i) = {mat2str(ADPATs(:,1,i))};
outputADPATs2(:,i) = {mat2str(ADPATs(:,2,i))};
outputADPATs3(:,i) = {mat2str(ADPATs(:,3,i))};

outputDMADPAs1(:,i) = {mat2str(DMADPAs(:,1,i))};
outputDMADPAs2(:,i) = {mat2str(DMADPAs(:,2,i))};
outputDMADPAs3(:,i) = {mat2str(DMADPAs(:,3,i))};
end
    
xlswrite('energy_spectrum.xlsx', outputAMsV1, '3m_eigenvector', 'B2');
xlswrite('energy_spectrum.xlsx', outputAMsV2, '3m_eigenvector', 'B3');
xlswrite('energy_spectrum.xlsx', outputAMsV3, '3m_eigenvector', 'B4');

xlswrite('energy_spectrum.xlsx', outputDMAMs1, '3m_eigenvector', 'B6');
xlswrite('energy_spectrum.xlsx', outputDMAMs2, '3m_eigenvector', 'B7');
xlswrite('energy_spectrum.xlsx', outputDMAMs3, '3m_eigenvector', 'B8');

xlswrite('energy_spectrum.xlsx', outputDPAMs1, '3m_eigenvector', 'B10');
xlswrite('energy_spectrum.xlsx', outputDPAMs2, '3m_eigenvector', 'B11');
xlswrite('energy_spectrum.xlsx', outputDPAMs3, '3m_eigenvector', 'B12');

xlswrite('energy_spectrum.xlsx', outputAATMs1, '3m_eigenvector', 'B14');
xlswrite('energy_spectrum.xlsx', outputAATMs2, '3m_eigenvector', 'B15');
xlswrite('energy_spectrum.xlsx', outputAATMs3, '3m_eigenvector', 'B16');

xlswrite('energy_spectrum.xlsx', outputDMA2s1, '3m_eigenvector', 'B18');
xlswrite('energy_spectrum.xlsx', outputDMA2s2, '3m_eigenvector', 'B19');
xlswrite('energy_spectrum.xlsx', outputDMA2s3, '3m_eigenvector', 'B20');

xlswrite('energy_spectrum.xlsx', outputDPA2s1, '3m_eigenvector', 'B22');
xlswrite('energy_spectrum.xlsx', outputDPA2s2, '3m_eigenvector', 'B23');
xlswrite('energy_spectrum.xlsx', outputDPA2s3, '3m_eigenvector', 'B24');

xlswrite('energy_spectrum.xlsx', outputADMATs1, '3m_eigenvector', 'B26');
xlswrite('energy_spectrum.xlsx', outputADMATs2, '3m_eigenvector', 'B27');
xlswrite('energy_spectrum.xlsx', outputADMATs3, '3m_eigenvector', 'B28');

xlswrite('energy_spectrum.xlsx', outputADPATs1, '3m_eigenvector', 'B30');
xlswrite('energy_spectrum.xlsx', outputADPATs2, '3m_eigenvector', 'B31');
xlswrite('energy_spectrum.xlsx', outputADPATs3, '3m_eigenvector', 'B32');

xlswrite('energy_spectrum.xlsx', outputDMADPAs1, '3m_eigenvector', 'B34');
xlswrite('energy_spectrum.xlsx', outputDMADPAs2, '3m_eigenvector', 'B35');
xlswrite('energy_spectrum.xlsx', outputDMADPAs3, '3m_eigenvector', 'B36');


%% 4m motif

pattern4m = [ 14 28 30 74 76 78 90 92 94 204 206 222 280 282 286 328 330 332 334 344 346 348 350 390 392 394 396 398 404 406 408 410 412 414 454 456 458 460 462 468 470 472 474 476 478 856 858 862 904 906 908 910 922 924 926 972 974 990 2184 2186 2190 2202 2204 2206 2252 2254 2270 2458 2462 2506 2510 2524 2526 3038 4370 4374 4382 4418 4420 4422 4424 4426 4428 4430 4434 4436 4438 4440 4442 4444 4446 4546 4548 4550 4556 4558 4562 4564 4566 4572 4574 4678 4682 4686 4692 4694 4698 4700 4702 4740 4742 4748 4750 4758 4764 4766 4812 4814 4830 4946 4950 4952 4954 4958 4994 4998 5002 5004 5006 5010 5012 5014 5016 5018 5020 5022 5058 5062 5064 5066 5068 5070 5074 5076 5078 5080 5082 5084 5086 6342 6348 6350 6356 6358 6364 6366 6550 6552 6554 6558 6598 6602 6604 6606 6614 6616 6618 6620 6622 6854 6858 6862 6870 6874 6876 6878 7126 7128 7130 7134 13142 13146 13148 13150 13260 13262 13278 14678 14686 14790 14798 14810 14812 14814 15258 15262 15310 15326 31710]; 

a4m=zeros(4,4,199);
for i=1:length(pattern4m)
    temp = dec2bin(pattern4m(i),16);
    temp2 = temp-48;
    temp3 = reshape(temp2,4,4);
    a4m(:,:,i) = temp3';
    e4m(:,i) = eig(a4m(:,:,i));
    [Ve4m(:,:,i),de4m(:,:,i)] = eig(a4m(:,:,i));
end
%% 4m motif LA
in4m=zeros(4,4,199);
DplusA4m=zeros(4,4,199);
for i=1:length(pattern4m)
    in4m(:,:,i)=diag(sum(a4m(:,:,i)))+diag(sum(a4m(:,:,i)'))-a4m(:,:,i);%D-A
    DplusA4m(:,:,i)=diag(sum(a4m(:,:,i)))+diag(sum(a4m(:,:,i)'))+a4m(:,:,i);%D+A

    ea4m(:,i) = eig(a4m(:,:,i));
    ie4m(:,i) = eig(in4m(:,:,i));
    Dpluse4m(:,i) = eig(DplusA4m(:,:,i));

    [iVa4m(:,:,i),ida4m(:,:,i)] = eig(a4m(:,:,i));
    [iVe4m(:,:,i),ide4m(:,:,i)] = eig(in4m(:,:,i));
    [DplusVe4m(:,:,i),Dplusde4m(:,:,i)] = eig(DplusA4m(:,:,i));

    gamma4m(:,i)=ie4m(:,i)-(((sum(sum(a4m(:,:,i))))*2)/4);
    Dplusgamma4m(:,i)=Dpluse4m(:,i)-(((sum(sum(a4m(:,:,i))))*2)/4);
    in4mMM(:,:,i)=in4m(:,:,i)*in4m(:,:,i)';
    ie4mMM(:,i) = eig(in4mMM(:,:,i));

    
      
    a4mMM(:,:,i)=a4m(:,:,i)*a4m(:,:,i)';
    a4mMMt(:,:,i)=a4m(:,:,i)'*a4m(:,:,i);
    [iVa4mMM(:,:,i),ida4mMM(:,:,i)] = eig(a4mMM(:,:,i));
    [iVa4mMMt(:,:,i),ida4mMMt(:,:,i)] = eig(a4mMMt(:,:,i));
    
    in4mMM(:,:,i)=in4m(:,:,i)*in4m(:,:,i)';
    in4mMMt(:,:,i)=in4m(:,:,i)'*in4m(:,:,i);
    [iVin4mMM(:,:,i),idin4mMM(:,:,i)] = eig(in4mMM(:,:,i));
    [iVin4mMMt(:,:,i),idin4mMMt(:,:,i)] = eig(in4mMMt(:,:,i));
    
    DplusA4mMM(:,:,i)=DplusA4m(:,:,i)*DplusA4m(:,:,i)';
    DplusA4mMMt(:,:,i)=DplusA4m(:,:,i)'*DplusA4m(:,:,i);
    [iVDplusA4mMM(:,:,i),idDplusA4mMM(:,:,i)] = eig(DplusA4mMM(:,:,i));
    [iVDplusA4mMMt(:,:,i),idDplusA4mMMt(:,:,i)] = eig(DplusA4mMMt(:,:,i));
    
    inDplus4mMM(:,:,i)=in4m(:,:,i)*DplusA4m(:,:,i)';
    [iVinDplus4mMMt(:,:,i),idinDplus4mMMt(:,:,i)] = eig(inDplus4mMM(:,:,i));%
    DplusinA4mMM(:,:,i)=DplusA4m(:,:,i)*in4m(:,:,i)'; 
    aDplus4mMM(:,:,i)=a4m(:,:,i)*DplusA4m(:,:,i)';%
    ainA4mMM(:,:,i)=a4m(:,:,i)*in4m(:,:,i)'; %
    [iVaDplus4mMMt(:,:,i),idaDplus4mMMt(:,:,i)] = eig(aDplus4mMM(:,:,i));%
    [iVainA4mMMt(:,:,i),idainA4mMMt(:,:,i)] = eig(ainA4mMM(:,:,i));%
    
    ae4mMM(:,i)=eig(a4mMM(:,:,i));
    ae4mMMt(:,i)=eig(a4mMMt(:,:,i));
    ide4mMM(:,i) = eig(in4mMM(:,:,i));
    ide4mMMt(:,i) = eig(in4mMMt(:,:,i));
    DplusAe4mMM(:,i) = eig(DplusA4mMM(:,:,i));
    DplusAe4mMMt(:,i) = eig(DplusA4mMMt(:,:,i));
    inDplusAe4mMM(:,i) = eig(inDplus4mMM(:,:,i));
    DplusinAe4mMMt(:,i) = eig(DplusinA4mMM(:,:,i));
    aDplusAe4mMM(:,i) = eig(aDplus4mMM(:,:,i));
    ainAe4mMMt(:,i) = eig(ainA4mMM(:,:,i));
    
    absDmAenergy4m(:,i) = sum(abs(ie4m(:,i)))-(((sum(sum(a4m(:,:,i))))*2)/4);
    absDpAergy4m(:,i) = sum(abs(Dpluse4m(:,i)))-(((sum(sum(a4m(:,:,i))))*2)/4);
end
iVe4m(find(abs(iVe4m)<0.000001)) = 0;
iVe4m = round (iVe4m,4,'significant');
DplusVe4m(find(abs(DplusVe4m)<0.000001)) = 0;
DplusVe4m = round (DplusVe4m,4,'significant');
iVa4m(find(abs(iVa4m)<0.000001)) = 0;
iVa4m = round (iVa4m,3,'significant');
iVa4mMM(find(abs(iVa4mMM)<0.000001)) = 0;
iVa4mMM = round (iVa4mMM,3,'significant');
iVa4mMMt(find(abs(iVa4mMMt)<0.000001)) = 0;
iVa4mMMt = round (iVa4mMMt,3,'significant');
iVin4mMM(find(abs(iVin4mMM)<0.000001)) = 0;
iVin4mMM = round (iVin4mMM,3,'significant');
iVin4mMMt(find(abs(iVin4mMMt)<0.000001)) = 0;
iVin4mMMt = round (iVin4mMMt,3,'significant');
iVDplusA4mMM(find(abs(iVDplusA4mMM)<0.000001)) = 0;
iVDplusA4mMM = round (iVDplusA4mMM,3,'significant');
iVDplusA4mMMt(find(abs(iVDplusA4mMMt)<0.000001)) = 0;
iVDplusA4mMMt = round (iVDplusA4mMMt,3,'significant');
inDplusAe4mMM(find(abs(inDplusAe4mMM)<0.000001)) = 0;
inDplusAe4mMM = round (inDplusAe4mMM,3,'significant');
DplusinAe4mMMt(find(abs(DplusinAe4mMMt)<0.000001)) = 0;
DplusinAe4mMMt = round (DplusinAe4mMMt,3,'significant');
aDplusAe4mMM(find(abs(aDplusAe4mMM)<0.000001)) = 0;
aDplusAe4mMM = round (aDplusAe4mMM,3,'significant');
ainAe4mMMt(find(abs(ainAe4mMMt)<0.000001)) = 0;
ainAe4mMMt = round (ainAe4mMMt,3,'significant');

%{
absea4m = abs(ea4m);
absie4m = abs(ie4m);
absie4m = sum(abs(sqrt(ie4m)));
absDplusAe4m = abs(Dpluse4m);
absDplusAe4m = sum(abs(sqrt(Dpluse4m)));
%}
absaenergy4m = sum(abs(ea4m));%energy A
%absDmAenergy4mon = sum(abs(ie4m));%energy DmA
%absDpAergy4mon = sum(abs(Dpluse4m));%energy DpA
absAAtenergy4m = sum(abs(sqrt(ae4mMM)));%energy A*At
absAtAenergy4m = sum(abs(sqrt(ae4mMMt))); %energy At*A
absDmAAAtenergy4m = sum(abs(sqrt(ide4mMM)));%energy DmA*DmAt
absDmAAtAenergy4m = sum(abs(sqrt(ide4mMMt)));%energy DmAt*DmA
absDpAAAtenergy4m = sum(abs(sqrt(DplusAe4mMM)));%energy DpA*DpAt
absDpAAtAenergy4m = sum(abs(sqrt(DplusAe4mMMt)));%energy DpAt*DpA
absDmADpAtenergy4m = sum(abs(sqrt(inDplusAe4mMM)));%energy DmA*DpAt
absDpADmAtenergy4m = sum(abs(sqrt(DplusinAe4mMMt)));%energy DpA*DmAt
absADpAtenergy4m = sum(abs(sqrt(aDplusAe4mMM)));%energy A*DpAt
absADmAtenergy4m = sum(abs(sqrt(ainAe4mMMt)));%energy A*DmAt

AM=Dpluse4m;
AM2=ie4m;

AMsV=DplusVe4m;
AMsV2=iVe4m;
for i=1:199
    if AM(1,i)>AM(2,i)
        temp=AM(1,i);
        AM(1,i)=AM(2,i);
        AM(2,i)=temp;
        temp=AMsV(:,1,i);
        AMsV(:,1,i)=AMsV(:,2,i);
        AMsV(:,2,i)=temp;
    end
    if AM(2,i)>AM(3,i)
        temp=AM(2,i);
        AM(2,i)=AM(3,i);
        AM(3,i)=temp;
        temp=AMsV(:,2,i);
        AMsV(:,2,i)=AMsV(:,3,i);
        AMsV(:,3,i)=temp;
    end
    if AM(3,i)>AM(4,i)
        temp=AM(3,i);
        AM(3,i)=AM(4,i);
        AM(4,i)=temp;
        temp=AMsV(:,3,i);
        AMsV(:,3,i)=AMsV(:,4,i);
        AMsV(:,4,i)=temp;
    end
    if AM(1,i)>AM(2,i)
        temp=AM(1,i);
        AM(1,i)=AM(2,i);
        AM(2,i)=temp;
        temp=AMsV(:,1,i);
        AMsV(:,1,i)=AMsV(:,2,i);
        AMsV(:,2,i)=temp;
    end
    if AM(2,i)>AM(3,i)
        temp=AM(2,i);
        AM(2,i)=AM(3,i);
        AM(3,i)=temp;
        temp=AMsV(:,2,i);
        AMsV(:,2,i)=AMsV(:,3,i);
        AMsV(:,3,i)=temp;
    end
    if AM(1,i)>AM(2,i)
        temp=AM(1,i);
        AM(1,i)=AM(2,i);
        AM(2,i)=temp;
        temp=AMsV(:,1,i);
        AMsV(:,1,i)=AMsV(:,2,i);
        AMsV(:,2,i)=temp;
    end
end

for i=1:199
    if AM2(1,i)>AM2(2,i)
        temp=AM2(1,i);
        AM2(1,i)=AM2(2,i);
        AM2(2,i)=temp;
        temp=AMsV2(:,1,i);
        AMsV2(:,1,i)=AMsV2(:,2,i);
        AMsV2(:,2,i)=temp;
    end
    if AM2(2,i)>AM2(3,i)
        temp=AM2(2,i);
        AM2(2,i)=AM2(3,i);
        AM2(3,i)=temp;
        temp=AMsV2(:,2,i);
        AMsV2(:,2,i)=AMsV2(:,3,i);
        AMsV2(:,3,i)=temp;
    end
     if AM2(3,i)>AM2(4,i)
        temp=AM2(3,i);
        AM2(3,i)=AM2(4,i);
        AM2(4,i)=temp;
        temp=AMsV2(:,3,i);
        AMsV2(:,3,i)=AMsV2(:,4,i);
        AMsV2(:,4,i)=temp;
    end
    if AM2(1,i)>AM2(2,i)
        temp=AM2(1,i);
        AM2(1,i)=AM2(2,i);
        AM2(2,i)=temp;
        temp=AMsV2(:,1,i);
        AMsV2(:,1,i)=AMsV2(:,2,i);
        AMsV2(:,2,i)=temp;
    end
     if AM2(2,i)>AM2(3,i)
        temp=AM2(2,i);
        AM2(2,i)=AM2(3,i);
        AM2(3,i)=temp;
        temp=AMsV2(:,2,i);
        AMsV2(:,2,i)=AMsV2(:,3,i);
        AMsV2(:,3,i)=temp;
     end
    if AM2(1,i)>AM2(2,i)
        temp=AM2(1,i);
        AM2(1,i)=AM2(2,i);
        AM2(2,i)=temp;
        temp=AMsV2(:,1,i);
        AMsV2(:,1,i)=AMsV2(:,2,i);
        AMsV2(:,2,i)=temp;
    end
end
AM(find(abs(AM)<0.000001)) = 0;
AM = round (AM,3,'significant');
AM2(find(abs(AM2)<0.000001)) = 0;
AM2 = round (AM2,3,'significant');
%%
xlswrite('test.xlsx', AM(1,:) , '4menergy', 'A1');
xlswrite('test.xlsx', AM(2,:) , '4menergy', 'A2');
xlswrite('test.xlsx', AM(3,:) , '4menergy', 'A3');
xlswrite('test.xlsx', AM(4,:) , '4menergy', 'A4');
xlswrite('test.xlsx', AM2(1,:) , '4menergy2', 'A1');
xlswrite('test.xlsx', AM2(2,:) , '4menergy2', 'A2');
xlswrite('test.xlsx', AM2(3,:) , '4menergy2', 'A3');
xlswrite('test.xlsx', AM2(4,:) , '4menergy2', 'A4');
%% energy output
xlswrite('energy.xlsx', {'pattern id'} , '3menergy', 'A1');
xlswrite('energy.xlsx', round(pattern3m,4,'significant') , '3menergy', 'B1');
xlswrite('energy.xlsx', {'E(G)'} , '3menergy', 'A2');
xlswrite('energy.xlsx', round(absaenergy3m,4,'significant') , '3menergy', 'B2');
xlswrite('energy.xlsx', {'LE(G)'} , '3menergy', 'A3');
xlswrite('energy.xlsx', round(absDmAenergy3m,4,'significant') , '3menergy', 'B3');
xlswrite('energy.xlsx', {'QE(G)'} , '3menergy', 'A4');
xlswrite('energy.xlsx', round(absDpAergy3m,4,'significant') , '3menergy', 'B4');
xlswrite('energy.xlsx', {'ME(G)AAt'} , '3menergy', 'A5');
xlswrite('energy.xlsx', round(absAAtenergy3m,4,'significant') , '3menergy', 'B5');
xlswrite('energy.xlsx', {'ME(G)AtA'} , '3menergy', 'A6');
xlswrite('energy.xlsx', round(absAtAenergy3m,4,'significant') , '3menergy', 'B6');
xlswrite('energy.xlsx', {'ME(G)DmADmAt'} , '3menergy', 'A7');
xlswrite('energy.xlsx', round(absDmAAAtenergy3m,4,'significant') , '3menergy', 'B7');
xlswrite('energy.xlsx', {'ME(G)DmAtDmA'} , '3menergy', 'A8');
xlswrite('energy.xlsx', round(absDmAAtAenergy3m,4,'significant') , '3menergy', 'B8');
xlswrite('energy.xlsx', {'ME(G)DpADpAt'} , '3menergy', 'A9');
xlswrite('energy.xlsx', round(absDpAAAtenergy3m,4,'significant') , '3menergy', 'B9');
xlswrite('energy.xlsx', {'ME(G)DpAtDpA'} , '3menergy', 'A10');
xlswrite('energy.xlsx', round(absDpAAtAenergy3m,4,'significant') , '3menergy', 'B10');
xlswrite('energy.xlsx', {'ME(G)DmADpAt'} , '3menergy', 'A11');
xlswrite('energy.xlsx', round(absDmADpAtenergy3m,4,'significant') , '3menergy', 'B11');
xlswrite('energy.xlsx', {'ME(G)DpAtDmA'} , '3menergy', 'A12');
xlswrite('energy.xlsx', round(absDpADmAtenergy3m,4,'significant') , '3menergy', 'B12');
xlswrite('energy.xlsx', {'ME(G)ADpAt'} , '3menergy', 'A13');
xlswrite('energy.xlsx', round(absADpAtenergy3m,4,'significant') , '3menergy', 'B13');
xlswrite('energy.xlsx', {'ME(G)ADmAt'} , '3menergy', 'A14');
xlswrite('energy.xlsx', round(absADmAtenergy3m,4,'significant') , '3menergy', 'B14');

xlswrite('energy.xlsx', {'pattern id'} , '4menergy', 'A1');
xlswrite('energy.xlsx', round(pattern4m,4,'significant') , '4menergy', 'B1');
xlswrite('energy.xlsx', {'E(G)'} , '4menergy', 'A2');
xlswrite('energy.xlsx', round(absaenergy4m,4,'significant') , '4menergy', 'B2');
xlswrite('energy.xlsx', {'LE(G)'} , '4menergy', 'A3');
xlswrite('energy.xlsx', round(absDmAenergy4m,4,'significant') , '4menergy', 'B3');
xlswrite('energy.xlsx', {'QE(G)'} , '4menergy', 'A4');
xlswrite('energy.xlsx', round(absDpAergy4m,4,'significant') , '4menergy', 'B4');
xlswrite('energy.xlsx', {'ME(G)AAt'} , '4menergy', 'A5');
xlswrite('energy.xlsx', round(absAAtenergy4m,4,'significant') , '4menergy', 'B5');
xlswrite('energy.xlsx', {'ME(G)AtA'} , '4menergy', 'A6');
xlswrite('energy.xlsx', round(absAtAenergy4m,4,'significant') , '4menergy', 'B6');
xlswrite('energy.xlsx', {'ME(G)DmADmAt'} , '4menergy', 'A7');
xlswrite('energy.xlsx', round(absDmAAAtenergy4m,4,'significant') , '4menergy', 'B7');
xlswrite('energy.xlsx', {'ME(G)DmAtDmA'} , '4menergy', 'A8');
xlswrite('energy.xlsx', round(absDmAAtAenergy4m,4,'significant') , '4menergy', 'B8');
xlswrite('energy.xlsx', {'ME(G)DpADpAt'} , '4menergy', 'A9');
xlswrite('energy.xlsx', round(absDpAAAtenergy4m,4,'significant') , '4menergy', 'B9');
xlswrite('energy.xlsx', {'ME(G)DpAtDpA'} , '4menergy', 'A10');
xlswrite('energy.xlsx', round(absDpAAtAenergy4m,4,'significant') , '4menergy', 'B10');
xlswrite('energy.xlsx', {'ME(G)DmADpAt'} , '4menergy', 'A11');
xlswrite('energy.xlsx', round(absDmADpAtenergy4m,4,'significant') , '4menergy', 'B11');
xlswrite('energy.xlsx', {'ME(G)DpAtDmA'} , '4menergy', 'A12');
xlswrite('energy.xlsx', round(absDpADmAtenergy4m,4,'significant') , '4menergy', 'B12');
xlswrite('energy.xlsx', {'ME(G)ADpAt'} , '4menergy', 'A13');
xlswrite('energy.xlsx', round(absADpAtenergy4m,4,'significant') , '4menergy', 'B13');
xlswrite('energy.xlsx', {'ME(G)ADmAt'} , '4menergy', 'A14');
xlswrite('energy.xlsx', round(absADmAtenergy4m,4,'significant') , '4menergy', 'B14');

%%
clear;clc;
%% entropy necessary information
[N,A,amount3m] = xlsread('3mentropy.xlsx','3m amount','A1:N47');
[N,A,amount4m] = xlsread('4mentropy.xlsx','4m amount','A1:GR47');
amount3mi = xlsread('3mentropy.xlsx','3m amount','A2:N47');
amount4mi = xlsread('4mentropy.xlsx','4m amount','A2:GR47');
%% entropy

for i=1:(length(amount4m(:,1))-2+1) %f19
    sop3m(i) = sum(amount3mi(i,:));
    sop4m(i) = sum(amount4mi(i,:));

    pop3m = amount3mi(i,:)./sop3m(i);
    pop4m = amount4mi(i,:)./sop4m(i);
    lpop3m = log2(pop3m);
    lpop3m(~pop3m) = 0;
    lpop4m = log2(pop4m);
    lpop4m(~pop4m) = 0;
    cpop3m(i,:)=pop3m;
    cpop4m(i,:)=pop4m;
    clpop3m(i,:)=lpop3m;
    clpop4m(i,:)=lpop4m;
    entropy3m(i) = -sum(pop3m.*lpop3m);
    entropy4m(i) = -sum(pop4m.*lpop4m); 
end
cpop3m(20,:) = [];
cpop4m(20,:) = [];
%% entropy output
xlswrite('entropy.xlsx', A , '3mentropy', 'A1');
xlswrite('entropy.xlsx', {'Total number of motifs'} , '3mentropy', 'B1');
xlswrite('entropy.xlsx', {'entropy'} , '3mentropy', 'C1');
xlswrite('entropy.xlsx', A , '4mentropy', 'A1');
xlswrite('entropy.xlsx', {'Total number of motifs'} , '4mentropy', 'B1');
xlswrite('entropy.xlsx', {'entropy' }, '4mentropy', 'C1');
xlswrite('entropy.xlsx', (sop3m') , '3mentropy', 'B2');
xlswrite('entropy.xlsx', (sop4m') , '4mentropy', 'B2');
xlswrite('entropy.xlsx', (round(entropy3m',4,'significant')) , '3mentropy', 'C2');
xlswrite('entropy.xlsx', (round(entropy4m',4,'significant')) , '4mentropy', 'C2');